import * as React from "react";
import * as PropTypes from "prop-types";
import { DIRECTION_AXIS } from "./ScrollbarTrack";
import { ElementProps } from "./Scrollbar";
import { DraggableData, DraggableEvent } from "react-draggable";
export declare type DragCallbackData = Pick<DraggableData, Exclude<keyof DraggableData, "node">>;
export declare type ScrollbarThumbProps = ElementProps & {
    axis: DIRECTION_AXIS;
    className?: string;
    style?: React.CSSProperties;
    onDrag?: (data: DragCallbackData) => void;
    onDragStart?: (data: DragCallbackData) => void;
    onDragEnd?: (data: DragCallbackData) => void;
    renderer?: React.FunctionComponent<ScrollbarThumbProps>;
};
export default class ScrollbarThumb extends React.Component<ScrollbarThumbProps, {}> {
    element: HTMLElement | null;
    private prevUserSelect;
    private prevOnSelectStart;
    initialOffsetX: number;
    initialOffsetY: number;
    lastDragData: DragCallbackData;
    static propTypes: {
        axis: PropTypes.Requireable<DIRECTION_AXIS>;
        className: PropTypes.Requireable<string>;
        style: PropTypes.Requireable<object>;
        onClick: PropTypes.Requireable<(...args: any[]) => any>;
        elementRef: PropTypes.Requireable<(...args: any[]) => any>;
        renderer: PropTypes.Requireable<(...args: any[]) => any>;
    };
    componentDidMount(): void;
    componentWillUnmount(): void;
    private static selectStartReplacer;
    handleOnDragStart: (ev: DraggableEvent, data: DraggableData) => void;
    handleOnDrag: (ev: DraggableEvent, data: DraggableData) => void;
    handleOnDragStop: (ev?: MouseEvent | React.MouseEvent<HTMLElement | SVGElement, MouseEvent> | React.TouchEvent<HTMLElement | SVGElement> | TouchEvent | undefined, data?: DraggableData | undefined) => void;
    handleOnMouseDown: (ev: MouseEvent) => void;
    render(): React.ReactElement<any> | null;
    private ref;
}
